Whamcloud - gitweb
LU-13903 tests: skip test_410 if modules weren't built
[fs/lustre-release.git] / lustre / tests / sanity.sh
index ddf1381..dba98f2 100755 (executable)
@@ -41,8 +41,8 @@ init_logging
 ALWAYS_EXCEPT="$SANITY_EXCEPT "
 # bug number for skipped test: LU-9693 LU-6493 LU-9693
 ALWAYS_EXCEPT+="               42a     42b     42c "
-# bug number:    LU-8411 LU-9054 LU-13314
-ALWAYS_EXCEPT+=" 407     312   56ob"
+# bug number:    LU-8411 LU-9054
+ALWAYS_EXCEPT+=" 407     312"
 
 if $SHARED_KEY; then
        # bug number:    LU-9795 LU-9795 LU-9795 LU-9795
@@ -144,6 +144,13 @@ check_swap_layouts_support()
                skip "Does not support layout lock."
 }
 
+check_swap_layout_no_dom()
+{
+       local FOLDER=$1
+       local SUPP=$(lfs getstripe $FOLDER | grep "pattern:       mdt" | wc -l)
+       [ $SUPP -eq 0 ] || skip "layout swap does not support DOM files so far"
+}
+
 check_and_setup_lustre
 DIR=${DIR:-$MOUNT}
 assert_DIR
@@ -1780,17 +1787,24 @@ run_test 27m "create file while OST0 was full"
 # OSCs keep a NOSPC flag that will be reset after ~5s (qos_maxage)
 # if the OST isn't full anymore.
 reset_enospc() {
-       local OSTIDX=${1:-""}
+       local ostidx=${1:-""}
+       local delay
+       local ready
+       local get_prealloc
 
        local list=$(comma_list $(osts_nodes))
-       [ "$OSTIDX" ] && list=$(facet_host ost$((OSTIDX + 1)))
+       [ "$ostidx" ] && list=$(facet_host ost$((ostidx + 1)))
 
        do_nodes $list lctl set_param fail_loc=0
-       sync    # initiate all OST_DESTROYs from MDS to OST
-       sleep_maxage
+       wait_delete_completed   # initiate all OST_DESTROYs from MDS to OST
+       delay=$(do_facet $SINGLEMDS lctl get_param -n lov.*.qos_maxage |
+               awk '{print $1 * 2;exit;}')
+       get_prealloc="$LCTL get_param -n osc.*MDT*.prealloc_status |
+                       grep -v \"^0$\""
+       wait_update_facet $SINGLEMDS "$get_prealloc" "" $delay
 }
 
-exhaust_precreations() {
+__exhaust_precreations() {
        local OSTIDX=$1
        local FAILLOC=$2
        local FAILIDX=${3:-$OSTIDX}
@@ -1821,14 +1835,19 @@ exhaust_precreations() {
        createmany -o $DIR/$tdir/${OST}/f $next_id $((last_id - next_id + 2))
        do_facet $mfacet lctl get_param osp.$mdtosc_proc2.prealloc*
        do_facet $ofacet lctl set_param fail_loc=$FAILLOC
+}
+
+exhaust_precreations() {
+       __exhaust_precreations $1 $2 $3
        sleep_maxage
 }
 
 exhaust_all_precreations() {
        local i
        for (( i=0; i < OSTCOUNT; i++ )) ; do
-               exhaust_precreations $i $1 -1
+               __exhaust_precreations $i $1 -1
        done
+       sleep_maxage
 }
 
 test_27n() {
@@ -2600,6 +2619,7 @@ test_27G() { #LU-10629
        local ostrange="0 0 1"
 
        test_mkdir $DIR/$tdir
+       touch $DIR/$tdir/$tfile.nopool
        pool_add $POOL || error "pool_add failed"
        pool_add_targets $POOL $ostrange || error "pool_add_targets failed"
        $LFS setstripe -p $POOL $DIR/$tdir
@@ -2607,14 +2627,18 @@ test_27G() { #LU-10629
        local pool=$($LFS getstripe -p $DIR/$tdir)
 
        [ "$pool" = "$POOL" ] || error "Striping failed got '$pool' not '$POOL'"
+       touch $DIR/$tdir/$tfile.default
+       $LFS setstripe -E 1M --pool $POOL -c 1 -E eof -c 1 $DIR/$tdir/$tfile.pfl
+       $LFS find $DIR/$tdir -type f --pool $POOL
+       local found=$($LFS find $DIR/$tdir -type f --pool $POOL | wc -l)
+       [[ "$found" == "2" ]] ||
+               error "found $found != 2 files in '$DIR/$tdir' in '$POOL'"
 
        $LFS setstripe -d $DIR/$tdir
 
-       pool=$($LFS getstripe -p $DIR/$tdir)
+       pool=$($LFS getstripe -p -d $DIR/$tdir)
 
-       rmdir $DIR/$tdir
-
-       [ -z "$pool" ] || error "'$pool' is not empty"
+       [[ "$pool" != "$POOL" ]] || error "$DIR/$tdir is still '$pool'"
 }
 run_test 27G "Clear OST pool from stripe"
 
@@ -3810,7 +3834,7 @@ test_33h() {
        done
 
        local failed=0
-       for i in {1..50}; do
+       for i in {1..250}; do
                for fname in $(mktemp -u $DIR/$tdir/.$tfile.XXXXXX) \
                             $(mktemp $DIR/$tdir/$tfile.XXXXXXXX); do
                        touch $fname  || error "touch $fname failed"
@@ -3822,7 +3846,7 @@ test_33h() {
                done
        done
        echo "$failed MDT index mismatches"
-       (( failed < 4 )) || error "MDT index mismatch $failed times"
+       (( failed < 20 )) || error "MDT index mismatch $failed times"
 
 }
 run_test 33h "temp file is located on the same MDT as target"
@@ -5624,16 +5648,24 @@ test_56c() {
        local ost_idx=0
        local ost_name=$(ostname_from_index $ost_idx)
        local old_status=$(ost_dev_status $ost_idx)
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
 
        [[ -z "$old_status" ]] ||
                skip_env "OST $ost_name is in $old_status status"
 
        do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=1
-       [[ $OST1_VERSION -ge $(version_code 2.12.55) ]] && do_facet ost1 \
+       [[ $OST1_VERSION -lt $(version_code 2.12.55) ]] || do_facet ost1 \
                $LCTL set_param -n obdfilter.$ost_name.no_precreate=1
+       if [[ $OST1_VERSION -ge $(version_code 2.12.57) ]]; then
+               save_lustre_params ost1 osd-*.$ost_name.nonrotational > $p
+               do_facet ost1 $LCTL set_param -n osd-*.$ost_name.nonrotational=1
+       fi
+
+       [[ $($LFS df -v $MOUNT |& grep -c "inactive device") -eq 0 ]] ||
+               error "$LFS df -v showing inactive devices"
        sleep_maxage
 
-       local new_status=$(ost_dev_status $ost_idx)
+       local new_status=$(ost_dev_status $ost_idx $MOUNT -v)
 
        [[ "$new_status" =~ "D" ]] ||
                error "$ost_name status is '$new_status', missing 'D'"
@@ -5641,18 +5673,37 @@ test_56c() {
                [[ "$new_status" =~ "N" ]] ||
                        error "$ost_name status is '$new_status', missing 'N'"
        fi
+       if [[ $OST1_VERSION -ge $(version_code 2.12.57) ]]; then
+               [[ "$new_status" =~ "f" ]] ||
+                       error "$ost_name status is '$new_status', missing 'f'"
+       fi
 
        do_facet ost1 $LCTL set_param -n obdfilter.$ost_name.degraded=0
-       [[ $OST1_VERSION -ge $(version_code 2.12.55) ]] && do_facet ost1 \
+       [[ $OST1_VERSION -lt $(version_code 2.12.55) ]] || do_facet ost1 \
                $LCTL set_param -n obdfilter.$ost_name.no_precreate=0
+       [[ -z "$p" ]] && restore_lustre_params < $p || true
        sleep_maxage
 
        new_status=$(ost_dev_status $ost_idx)
        [[ ! "$new_status" =~ "D" && ! "$new_status" =~ "N" ]] ||
                error "$ost_name status is '$new_status', has 'D' and/or 'N'"
+       # can't check 'f' as devices may actually be on flash
 }
 run_test 56c "check 'lfs df' showing device status"
 
+test_56d() {
+       local mdts=$($LFS df -v $MOUNT | grep -c MDT)
+       local osts=$($LFS df -v $MOUNT | grep -c OST)
+
+       $LFS df $MOUNT
+
+       (( mdts == MDSCOUNT )) ||
+               error "lfs df -v showed $mdts MDTs, not $MDSCOUNT"
+       (( osts == OSTCOUNT )) ||
+               error "lfs df -v showed $osts OSTs, not $OSTCOUNT"
+}
+run_test 56d "'lfs df -v' prints only configured devices"
+
 NUMFILES=3
 NUMDIRS=3
 setup_56() {
@@ -5868,7 +5919,7 @@ test_56ob() {
        cmd="$LFS find $dir -ctime +1s -type f"
        nums=$($cmd | wc -l)
        (( $nums == $count * 2 + 1)) ||
-               error "'$cmd' wrong: found $nums, expected $((expected*2+1))"
+               error "'$cmd' wrong: found $nums, expected $((count * 2 + 1))"
 }
 run_test 56ob "check lfs find -atime -mtime -ctime with units"
 
@@ -6152,154 +6203,67 @@ test_56r() {
 }
 run_test 56r "check lfs find -size works"
 
-test_56ra() {
-       [[ $MDS1_VERSION -gt $(version_code 2.12.58) ]] ||
-               skip "MDS < 2.12.58 doesn't return LSOM data"
-       local dir=$DIR/$tdir
-
-       [[ $OSC == "mdc" ]] && skip "DoM files" && return
-
-       setup_56 $dir $NUMFILES $NUMDIRS "-c 1"
+test_56ra_sub() {
+       local expected=$1
+       local glimpses=$2
+       local cmd="$3"
 
        cancel_lru_locks $OSC
 
        local rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       local expected=12
-       local cmd="$LFS find -size 0 -type f -lazy $dir"
        local nums=$($cmd | wc -l)
 
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
 
        local rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size 0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       $LCTL get_param osc.*.stats
-       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
-               error "'$cmd' should send 12 glimpse RPCs to OST"
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=0
-       cmd="$LFS find ! -size 0 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       $LCTL get_param mdc.*.stats
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find ! -size 0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
-               error "'$cmd' should send 12 glimpse RPCs to OST"
+       if (( rpcs_before + glimpses != rpcs_after )); then
+               echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+               $LCTL get_param osc.*.stats | grep ldlm_glimpse_enqueue
 
-       echo "test" > $dir/$tfile
-       echo "test2" > $dir/$tfile.2 && sync
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=1
-       cmd="$LFS find -size 5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size 5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+               if [[ $glimpses == 0 ]]; then
+                       error "'$cmd' should not send glimpse RPCs to OST"
+               else
+                       error "'$cmd' should send $glimpses glimpse RPCs to OST"
+               fi
+       fi
+}
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=1
-       cmd="$LFS find -size +5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size +5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+test_56ra() {
+       [[ $MDS1_VERSION -gt $(version_code 2.12.58) ]] ||
+               skip "MDS < 2.12.58 doesn't return LSOM data"
+       local dir=$DIR/$tdir
 
-       cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=2
-       cmd="$LFS find -size +0 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size +0 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       [[ $OSC == "mdc" ]] && skip "DoM files" && return
 
+       setup_56 $dir $NUMFILES $NUMDIRS "-c 1"
+       # open and close all files to ensure LSOM is updated
        cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=2
-       cmd="$LFS find ! -size -5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find ! -size -5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       find $dir -type f | xargs cat > /dev/null
 
+       #   expect_found  glimpse_rpcs  command_to_run
+       test_56ra_sub 12  0 "$LFS find -size 0 -type f -lazy $dir"
+       test_56ra_sub 12 12 "$LFS find -size 0 -type f $dir"
+       test_56ra_sub  0  0 "$LFS find ! -size 0 -type f -lazy $dir"
+       test_56ra_sub  0 12 "$LFS find ! -size 0 -type f $dir"
+
+       echo "test" > $dir/$tfile
+       echo "test2" > $dir/$tfile.2 && sync
        cancel_lru_locks $OSC
-       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       expected=12
-       cmd="$LFS find -size -5 -type f -lazy $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       [ $rpcs_before -eq $rpcs_after ] ||
-               error "'$cmd' should not send glimpse RPCs to OST"
-       cmd="$LFS find -size -5 -type f $dir"
-       nums=$($cmd | wc -l)
-       [ $nums -eq $expected ] ||
-               error "'$cmd' wrong: found $nums, expected $expected"
-       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
-       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
-       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
-               error "'$cmd' should send 14 glimpse RPCs to OST"
+       cat $dir/$tfile $dir/$tfile.2 > /dev/null
+
+       test_56ra_sub  1  0 "$LFS find -size 5 -type f -lazy $dir"
+       test_56ra_sub  1 14 "$LFS find -size 5 -type f $dir"
+       test_56ra_sub  1  0 "$LFS find -size +5 -type f -lazy $dir"
+       test_56ra_sub  1 14 "$LFS find -size +5 -type f $dir"
+
+       test_56ra_sub  2  0 "$LFS find -size +0 -type f -lazy $dir"
+       test_56ra_sub  2 14 "$LFS find -size +0 -type f $dir"
+       test_56ra_sub  2  0 "$LFS find ! -size -5 -type f -lazy $dir"
+       test_56ra_sub  2 14 "$LFS find ! -size -5 -type f $dir"
+       test_56ra_sub 12  0 "$LFS find -size -5 -type f -lazy $dir"
+       test_56ra_sub 12 14 "$LFS find -size -5 -type f $dir"
 }
 run_test 56ra "check lfs find -size -lazy works for data on OSTs"
 
@@ -6311,14 +6275,15 @@ test_56rb() {
        test_mkdir -p $dir || error "failed to mkdir $dir"
        $LFS setstripe -c 1 -i 0 $dir/$tfile ||
                error "failed to setstripe $dir/$tfile"
+       mdt_idx=$($LFS getdirstripe -i $dir)
        dd if=/dev/zero of=$dir/$tfile bs=1M count=1
 
        stack_trap "rm -f $tmp" EXIT
-       $LFS find --size +100K --ost 0 $dir 2>&1 | tee $tmp
-       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+       $LFS find --size +100K --ost 0 $dir |& tee $tmp
+       ! grep -q obd_uuid $tmp ||
                error "failed to find --size +100K --ost 0 $dir"
-       $LFS find --size +100K --mdt $mdt_idx $dir 2>&1 | tee $tmp
-       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+       $LFS find --size +100K --mdt $mdt_idx $dir |& tee $tmp
+       ! grep -q obd_uuid $tmp ||
                error "failed to find --size +100K --mdt $mdt_idx $dir"
 }
 run_test 56rb "check lfs find --size --ost/--mdt works"
@@ -6844,6 +6809,24 @@ test_56wd() {
 }
 run_test 56wd "check lfs_migrate --rsync and --no-rsync work"
 
+test_56we() {
+       local td=$DIR/$tdir
+       local tf=$td/$tfile
+
+       test_mkdir $td || error "cannot create $td"
+       touch $tf || error "cannot touch $tf"
+
+       echo -n "Make sure --non-direct|-D works..."
+       $LFS_MIGRATE -y --non-direct -v $tf 2>&1 |
+               grep -q "lfs migrate --non-direct" ||
+               error "--non-direct option cannot work correctly"
+       $LFS_MIGRATE -y -D -v $tf 2>&1 |
+               grep -q "lfs migrate -D" ||
+               error "-D option cannot work correctly"
+       echo "done."
+}
+run_test 56we "check lfs_migrate --non-direct|-D support"
+
 test_56x() {
        [[ $OSTCOUNT -lt 2 ]] && skip_env "needs >= 2 OSTs"
        check_swap_layouts_support
@@ -7864,18 +7847,25 @@ test_64c() {
 }
 run_test 64c "verify grant shrink"
 
+import_param() {
+       local tgt=$1
+       local param=$2
+
+       $LCTL get_param osc.$tgt.import | awk "/$param/ { print \$2 }"
+}
+
 # this does exactly what osc_request.c:osc_announce_cached() does in
 # order to calculate max amount of grants to ask from server
 want_grant() {
        local tgt=$1
 
-       local nrpages=$($LCTL get_param -n osc.${tgt}.max_pages_per_rpc)
-       local rpc_in_flight=$($LCTL get_param -n osc.${tgt}.max_rpcs_in_flight)
+       local nrpages=$($LCTL get_param -n osc.$tgt.max_pages_per_rpc)
+       local rpc_in_flight=$($LCTL get_param -n osc.$tgt.max_rpcs_in_flight)
 
-       ((rpc_in_flight ++));
+       ((rpc_in_flight++));
        nrpages=$((nrpages * rpc_in_flight))
 
-       local dirty_max_pages=$($LCTL get_param -n osc.${tgt}.max_dirty_mb)
+       local dirty_max_pages=$($LCTL get_param -n osc.$tgt.max_dirty_mb)
 
        dirty_max_pages=$((dirty_max_pages * 1024 * 1024 / PAGE_SIZE))
 
@@ -7883,13 +7873,11 @@ want_grant() {
        local undirty=$((nrpages * PAGE_SIZE))
 
        local max_extent_pages
-       max_extent_pages=$($LCTL get_param osc.${tgt}.import |
-           grep grant_max_extent_size | awk '{print $2}')
+       max_extent_pages=$(import_param $tgt grant_max_extent_size)
        max_extent_pages=$((max_extent_pages / PAGE_SIZE))
        local nrextents=$(((nrpages + max_extent_pages - 1) / max_extent_pages))
        local grant_extent_tax
-       grant_extent_tax=$($LCTL get_param osc.${tgt}.import |
-           grep grant_extent_tax | awk '{print $2}')
+       grant_extent_tax=$(import_param $tgt grant_extent_tax)
 
        undirty=$((undirty + nrextents * grant_extent_tax))
 
@@ -7903,56 +7891,171 @@ grant_chunk() {
        local max_brw_size
        local grant_extent_tax
 
-       max_brw_size=$($LCTL get_param osc.${tgt}.import |
-           grep max_brw_size | awk '{print $2}')
+       max_brw_size=$(import_param $tgt max_brw_size)
 
-       grant_extent_tax=$($LCTL get_param osc.${tgt}.import |
-           grep grant_extent_tax | awk '{print $2}')
+       grant_extent_tax=$(import_param $tgt grant_extent_tax)
 
        echo $(((max_brw_size + grant_extent_tax) * 2))
 }
 
 test_64d() {
-       [ $OST1_VERSION -lt $(version_code 2.10.56) ] &&
+       [ $OST1_VERSION -ge $(version_code 2.10.56) ] ||
                skip "OST < 2.10.55 doesn't limit grants enough"
 
-       local tgt=$($LCTL dl | grep "0000-osc-[^mM]" | awk '{print $4}')
-       local file=$DIR/$tfile
+       local tgt=$($LCTL dl | awk '/OST0000-osc-[^mM]/ { print $4 }')
 
-       [[ $($LCTL get_param osc.${tgt}.import |
-            grep "connect_flags:.*grant_param") ]] ||
+       [[ "$($LCTL get_param osc.${tgt}.import)" =~ "grant_param" ]] ||
                skip "no grant_param connect flag"
 
-       local olddebug=$($LCTL get_param -n debug 2> /dev/null)
+       local olddebug="$($LCTL get_param -n debug 2> /dev/null)"
+
+       $LCTL set_param -n -n debug="$OLDDEBUG" || true
+       stack_trap "$LCTL set_param -n debug='$olddebug'" EXIT
 
-       $LCTL set_param debug="$OLDDEBUG" 2> /dev/null || true
 
        local max_cur_granted=$(($(want_grant $tgt) + $(grant_chunk $tgt)))
-       stack_trap "rm -f $file" EXIT
+       stack_trap "rm -f $DIR/$tfile && wait_delete_completed" EXIT
 
-       $LFS setstripe $file -i 0 -c 1
-       dd if=/dev/zero of=$file bs=1M count=1000 &
+       $LFS setstripe $DIR/$tfile -i 0 -c 1
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1000 &
        ddpid=$!
 
-       while true
-       do
-               local cur_grant=$($LCTL get_param -n osc.${tgt}.cur_grant_bytes)
-               if [[ $cur_grant -gt $max_cur_granted ]]
-               then
+       while kill -0 $ddpid; do
+               local cur_grant=$($LCTL get_param -n osc.$tgt.cur_grant_bytes)
+
+               if [[ $cur_grant -gt $max_cur_granted ]]; then
                        kill $ddpid
                        error "cur_grant $cur_grant > $max_cur_granted"
                fi
-               kill -0 $ddpid
-               [[ $? -ne 0 ]] && break;
-               sleep 2
-       done
 
-       rm -f $DIR/$tfile
-       wait_delete_completed
-       $LCTL set_param debug="$olddebug" 2> /dev/null || true
+               sleep 1
+       done
 }
 run_test 64d "check grant limit exceed"
 
+check_grants() {
+       local tgt=$1
+       local expected=$2
+       local msg=$3
+       local cur_grants=$($LCTL get_param -n osc.$tgt.cur_grant_bytes)
+
+       ((cur_grants == expected)) ||
+               error "$msg: grants mismatch: $cur_grants, expected $expected"
+}
+
+round_up_p2() {
+       echo $((($1 + $2 - 1) & ~($2 - 1)))
+}
+
+test_64e() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       [ $OST1_VERSION -ge $(version_code 2.11.56) ] ||
+               skip "Need OSS version at least 2.11.56"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       local osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       local init_grants=$(import_param $osc_tgt initial_grant)
+
+       check_grants $osc_tgt $init_grants "init grants"
+
+       local extent_tax=$(import_param $osc_tgt grant_extent_tax)
+       local max_brw_size=$(import_param $osc_tgt max_brw_size)
+       local gbs=$(import_param $osc_tgt grant_block_size)
+
+       # write random number of bytes from max_brw_size / 4 to max_brw_size
+       local write_bytes=$(shuf -i $((max_brw_size / 4))-$max_brw_size -n 1)
+       # align for direct io
+       write_bytes=$(round_up_p2 $write_bytes PAGE_SIZE)
+       # round to grant consumption unit
+       local wb_round_up=$(round_up_p2 $write_bytes gbs)
+
+       local grants=$((wb_round_up + extent_tax))
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile  || error "lfs setstripe failed"
+
+       # define OBD_FAIL_TGT_NO_GRANT 0x725
+       # make the server not grant more back
+       do_facet ost1 $LCTL set_param fail_loc=0x725
+       dd if=/dev/zero of=$DIR/$tfile bs=$write_bytes count=1 oflag=direct
+
+       do_facet ost1 $LCTL set_param fail_loc=0
+
+       check_grants $osc_tgt $((init_grants - grants)) "dio w/o grant alloc"
+
+       rm -f $DIR/$tfile || error "rm failed"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+
+       # define OBD_FAIL_TGT_NO_GRANT 0x725
+       # make the server not grant more back
+       do_facet ost1 $LCTL set_param fail_loc=0x725
+       $MULTIOP $DIR/$tfile "oO_WRONLY:w${write_bytes}yc"
+       do_facet ost1 $LCTL set_param fail_loc=0
+
+       check_grants $osc_tgt $((init_grants - grants)) "buf io w/o grant alloc"
+}
+run_test 64e "check grant consumption (no grant allocation)"
+
+test_64f() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       local osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       local init_grants=$(import_param $osc_tgt initial_grant)
+       local extent_tax=$(import_param $osc_tgt grant_extent_tax)
+       local max_brw_size=$(import_param $osc_tgt max_brw_size)
+       local gbs=$(import_param $osc_tgt grant_block_size)
+       local chunk=$(grant_chunk $osc_tgt)
+
+       # write random number of bytes from max_brw_size / 4 to max_brw_size
+       local write_bytes=$(shuf -i $((max_brw_size / 4))-$max_brw_size -n 1)
+       # align for direct io
+       write_bytes=$(round_up_p2 $write_bytes PAGE_SIZE)
+       # round to grant consumption unit
+       local wb_round_up=$(round_up_p2 $write_bytes gbs)
+
+       local grants=$((wb_round_up + extent_tax))
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+       dd if=/dev/zero of=$DIR/$tfile bs=$write_bytes count=1 oflag=direct ||
+               error "error writing to $DIR/$tfile"
+
+       check_grants $osc_tgt $((init_grants - grants + chunk)) \
+               "direct io with grant allocation"
+
+       rm -f $DIR/$tfile || error "rm failed"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+
+       local cmd="oO_WRONLY:w${write_bytes}_yc"
+
+       $MULTIOP $DIR/$tfile $cmd &
+       MULTIPID=$!
+       sleep 1
+
+       check_grants $osc_tgt $((init_grants - grants)) \
+               "buffered io, not write rpc"
+
+       kill -USR1 $MULTIPID
+       wait
+
+       check_grants $osc_tgt $((init_grants - grants + chunk)) \
+               "buffered io, one RPC"
+}
+run_test 64f "check grant consumption (with grant allocation)"
+
 # bug 1414 - set/get directories' stripe info
 test_65a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -8505,6 +8608,8 @@ test_74c() {
 run_test 74c "ldlm_lock_create error path, (shouldn't LBUG)"
 
 num_inodes() {
+       [ -f /sys/kernel/slab/lustre_inode_cache/shrink ] &&
+               echo 1 > /sys/kernel/slab/lustre_inode_cache/shrink
        awk '/lustre_inode_cache/ {print $2; exit}' /proc/slabinfo
 }
 
@@ -8794,9 +8899,8 @@ test_77k() { # LU-10906
        local i
 
        [ "$ORIG_CSUM" ] || ORIG_CSUM=$(eval $get_checksum)
-       stack_trap "wait_update $HOSTNAME '$get_checksum' $ORIG_CSUM" EXIT
-       stack_trap "do_facet mgs $LCTL set_param -P $cksum_param=$ORIG_CSUM" \
-               EXIT
+       stack_trap "wait_update $HOSTNAME '$get_checksum' $ORIG_CSUM || true"
+       stack_trap "do_facet mgs $LCTL set_param -P $cksum_param=$ORIG_CSUM"
 
        for i in 0 1; do
                do_facet mgs $LCTL set_param -P $cksum_param=$i ||
@@ -9019,28 +9123,6 @@ test_81b() { # LU-456
 }
 run_test 81b "OST should return -ENOSPC when retry still fails ======="
 
-test_82() { # LU-1031
-       dd if=/dev/zero of=$DIR/$tfile bs=1M count=10
-       local gid1=14091995
-       local gid2=16022000
-
-       multiop_bg_pause $DIR/$tfile OG${gid1}_g${gid1}c || return 1
-       local MULTIPID1=$!
-       multiop_bg_pause $DIR/$tfile O_G${gid2}r10g${gid2}c || return 2
-       local MULTIPID2=$!
-       kill -USR1 $MULTIPID2
-       sleep 2
-       if [[ `ps h -o comm -p $MULTIPID2` == "" ]]; then
-               error "First grouplock does not block second one"
-       else
-               echo "Second grouplock blocks first one"
-       fi
-       kill -USR1 $MULTIPID1
-       wait $MULTIPID1
-       wait $MULTIPID2
-}
-run_test 82 "Basic grouplock test"
-
 test_99() {
        [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs"
 
@@ -11485,8 +11567,8 @@ test_121() { #bug #10589
 }
 run_test 121 "read cancel race ========="
 
-test_123a() { # was test 123, statahead(bug 11401)
-       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+test_123a_base() { # was test 123, statahead(bug 11401)
+       local lsx="$1"
 
        SLOWOK=0
        if ! grep -q "processor.*: 1" /proc/cpuinfo; then
@@ -11498,76 +11580,120 @@ test_123a() { # was test 123, statahead(bug 11401)
        test_mkdir $DIR/$tdir
        NUMFREE=$(df -i -P $DIR | tail -n 1 | awk '{ print $4 }')
        [[ $NUMFREE -gt 100000 ]] && NUMFREE=100000 || NUMFREE=$((NUMFREE-1000))
-        MULT=10
-        for ((i=100, j=0; i<=$NUMFREE; j=$i, i=$((i * MULT)) )); do
-                createmany -o $DIR/$tdir/$tfile $j $((i - j))
-
-                max=`lctl get_param -n llite.*.statahead_max | head -n 1`
-                lctl set_param -n llite.*.statahead_max 0
-                lctl get_param llite.*.statahead_max
-                cancel_lru_locks mdc
-                cancel_lru_locks osc
-                stime=`date +%s`
-                time ls -l $DIR/$tdir | wc -l
-                etime=`date +%s`
-                delta=$((etime - stime))
-                log "ls $i files without statahead: $delta sec"
-                lctl set_param llite.*.statahead_max=$max
-
-                swrong=`lctl get_param -n llite.*.statahead_stats | grep "statahead wrong:" | awk '{print $3}'`
-                lctl get_param -n llite.*.statahead_max | grep '[0-9]'
-                cancel_lru_locks mdc
-                cancel_lru_locks osc
-                stime=`date +%s`
-                time ls -l $DIR/$tdir | wc -l
-                etime=`date +%s`
-                delta_sa=$((etime - stime))
-                log "ls $i files with statahead: $delta_sa sec"
-                lctl get_param -n llite.*.statahead_stats
-                ewrong=`lctl get_param -n llite.*.statahead_stats | grep "statahead wrong:" | awk '{print $3}'`
+       MULT=10
+       for ((i=100, j=0; i<=$NUMFREE; j=$i, i=$((i * MULT)) )); do
+               createmany -o $DIR/$tdir/$tfile $j $((i - j))
+
+               max=$(lctl get_param -n llite.*.statahead_max | head -n 1)
+               lctl set_param -n llite.*.statahead_max 0
+               lctl get_param llite.*.statahead_max
+               cancel_lru_locks mdc
+               cancel_lru_locks osc
+               stime=$(date +%s)
+               time $lsx $DIR/$tdir | wc -l
+               etime=$(date +%s)
+               delta=$((etime - stime))
+               log "$lsx $i files without statahead: $delta sec"
+               lctl set_param llite.*.statahead_max=$max
+
+               swrong=$(lctl get_param -n llite.*.statahead_stats |
+                       grep "statahead wrong:" | awk '{print $3}')
+               lctl get_param -n llite.*.statahead_max | grep '[0-9]'
+               cancel_lru_locks mdc
+               cancel_lru_locks osc
+               stime=$(date +%s)
+               time $lsx $DIR/$tdir | wc -l
+               etime=$(date +%s)
+               delta_sa=$((etime - stime))
+               log "$lsx $i files with statahead: $delta_sa sec"
+               lctl get_param -n llite.*.statahead_stats
+               ewrong=$(lctl get_param -n llite.*.statahead_stats |
+                       grep "statahead wrong:" | awk '{print $3}')
 
                [[ $swrong -lt $ewrong ]] &&
                        log "statahead was stopped, maybe too many locks held!"
                [[ $delta -eq 0 || $delta_sa -eq 0 ]] && continue
 
-                if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
-                    max=`lctl get_param -n llite.*.statahead_max | head -n 1`
-                    lctl set_param -n llite.*.statahead_max 0
-                    lctl get_param llite.*.statahead_max
-                    cancel_lru_locks mdc
-                    cancel_lru_locks osc
-                    stime=`date +%s`
-                    time ls -l $DIR/$tdir | wc -l
-                    etime=`date +%s`
-                    delta=$((etime - stime))
-                    log "ls $i files again without statahead: $delta sec"
-                    lctl set_param llite.*.statahead_max=$max
-                    if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
-                        if [  $SLOWOK -eq 0 ]; then
-                                error "ls $i files is slower with statahead!"
-                        else
-                                log "ls $i files is slower with statahead!"
-                        fi
-                        break
-                    fi
-                fi
+               if [ $((delta_sa * 100)) -gt $((delta * 105)) -a $delta_sa -gt $((delta + 2)) ]; then
+                       max=$(lctl get_param -n llite.*.statahead_max |
+                               head -n 1)
+                       lctl set_param -n llite.*.statahead_max 0
+                       lctl get_param llite.*.statahead_max
+                       cancel_lru_locks mdc
+                       cancel_lru_locks osc
+                       stime=$(date +%s)
+                       time $lsx $DIR/$tdir | wc -l
+                       etime=$(date +%s)
+                       delta=$((etime - stime))
+                       log "$lsx $i files again without statahead: $delta sec"
+                       lctl set_param llite.*.statahead_max=$max
+                       if [ $((delta_sa * 100 > delta * 105 && delta_sa > delta + 2)) ]; then
+                               if [  $SLOWOK -eq 0 ]; then
+                                       error "$lsx $i files is slower with statahead!"
+                               else
+                                       log "$lsx $i files is slower with statahead!"
+                               fi
+                               break
+                       fi
+               fi
 
-                [ $delta -gt 20 ] && break
-                [ $delta -gt 8 ] && MULT=$((50 / delta))
-                [ "$SLOW" = "no" -a $delta -gt 5 ] && break
-        done
-        log "ls done"
+               [ $delta -gt 20 ] && break
+               [ $delta -gt 8 ] && MULT=$((50 / delta))
+               [ "$SLOW" = "no" -a $delta -gt 5 ] && break
+       done
+       log "$lsx done"
 
-        stime=`date +%s`
-        rm -r $DIR/$tdir
-        sync
-        etime=`date +%s`
-        delta=$((etime - stime))
-        log "rm -r $DIR/$tdir/: $delta seconds"
-        log "rm done"
-        lctl get_param -n llite.*.statahead_stats
+       stime=$(date +%s)
+       rm -r $DIR/$tdir
+       sync
+       etime=$(date +%s)
+       delta=$((etime - stime))
+       log "rm -r $DIR/$tdir/: $delta seconds"
+       log "rm done"
+       lctl get_param -n llite.*.statahead_stats
+}
+
+test_123aa() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       test_123a_base "ls -l"
+}
+run_test 123aa "verify statahead work"
+
+test_123ab() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       statx_supported || skip_env "Test must be statx() syscall supported"
+
+       test_123a_base "$STATX -l"
 }
-run_test 123a "verify statahead work"
+run_test 123ab "verify statahead work by using statx"
+
+test_123ac() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       statx_supported || skip_env "Test must be statx() syscall supported"
+
+       local rpcs_before
+       local rpcs_after
+       local agl_before
+       local agl_after
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       agl_before=$($LCTL get_param -n llite.*.statahead_stats |
+               awk '/agl.total:/ {print $3}')
+       test_123a_base "$STATX -c \"%n %i %A %h %u %g %W %X %Z\" -D"
+       test_123a_base "$STATX --cached=always -D"
+       agl_after=$($LCTL get_param -n llite.*.statahead_stats |
+               awk '/agl.total:/ {print $3}')
+       [ $agl_before -eq $agl_after ] ||
+               error "Should not trigger AGL thread - $agl_before:$agl_after"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_after -eq $rpcs_before ] ||
+               error "$STATX should not send glimpse RPCs to $OSC"
+}
+run_test 123ac "verify statahead work by using statx without glimpse RPCs"
 
 test_123b () { # statahead(bug 15027)
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -12092,7 +12218,7 @@ set_dir_limits () {
 check_mds_dmesg() {
        local facets=$(get_facets MDS)
        for facet in ${facets//,/ }; do
-               do_facet $facet "dmesg | tail -3 | grep -q $1" && return 0
+               do_facet $facet "dmesg | tail -3 | grep $1" && return 0
        done
        return 1
 }
@@ -12107,55 +12233,49 @@ test_129() {
        remote_mds_nodsh && skip "remote MDS with nodsh"
 
        local ENOSPC=28
-       local EFBIG=27
        local has_warning=false
 
        rm -rf $DIR/$tdir
        mkdir -p $DIR/$tdir
 
        # block size of mds1
-       local maxsize=$(($($LCTL get_param -n mdc.*MDT0000*.blocksize) * 5))
-       set_dir_limits $maxsize $maxsize
+       local maxsize=$(($($LCTL get_param -n mdc.*MDT0000*.blocksize) * 8))
+       set_dir_limits $maxsize $((maxsize * 6 / 8))
+       stack_trap "set_dir_limits 0 0"
+       stack_trap "unlinkmany $DIR/$tdir/file_base_ 2000 || true"
        local dirsize=$(stat -c%s "$DIR/$tdir")
        local nfiles=0
-       while [[ $dirsize -le $maxsize ]]; do
-               $MULTIOP $DIR/$tdir/file_base_$nfiles Oc
+       while (( $dirsize <= $maxsize )); do
+               $MCREATE $DIR/$tdir/file_base_$nfiles
                rc=$?
-               if ! $has_warning; then
-                       check_mds_dmesg '"is approaching"' && has_warning=true
-               fi
                # check two errors:
-               # ENOSPC for new ext4 max_dir_size (kernel commit df981d03ee)
-               # EFBIG for previous versions included in ldiskfs series
-               if [ $rc -eq $EFBIG ] || [ $rc -eq $ENOSPC ]; then
+               # ENOSPC for ext4 max_dir_size, which has been used since
+               # kernel v3.6-rc1-8-gdf981d03ee, lustre v2_4_50_0-79-gaed82035c0
+               if (( rc == ENOSPC )); then
                        set_dir_limits 0 0
-                       echo "return code $rc received as expected"
+                       echo "rc=$rc returned as expected after $nfiles files"
 
                        createmany -o $DIR/$tdir/file_extra_$nfiles. 5 ||
-                               error_exit "create failed w/o dir size limit"
-
-                       check_mds_dmesg '"has reached"' ||
-                               error_exit "reached message should be output"
+                               error "create failed w/o dir size limit"
 
-                       [ $has_warning = "false" ] &&
-                               error_exit "warning message should be output"
+                       # messages may be rate limited if test is run repeatedly
+                       check_mds_dmesg '"is approaching max"' ||
+                               echo "warning message should be output"
+                       check_mds_dmesg '"has reached max"' ||
+                               echo "reached message should be output"
 
                        dirsize=$(stat -c%s "$DIR/$tdir")
 
                        [[ $dirsize -ge $maxsize ]] && return 0
-                       error_exit "current dir size $dirsize, " \
-                                  "previous limit $maxsize"
-               elif [ $rc -ne 0 ]; then
-                       set_dir_limits 0 0
-                       error_exit "return $rc received instead of expected " \
-                                  "$EFBIG or $ENOSPC, files in dir $dirsize"
+                       error "dirsize $dirsize < $maxsize after $nfiles files"
+               elif (( rc != 0 )); then
+                       break
                fi
                nfiles=$((nfiles + 1))
                dirsize=$(stat -c%s "$DIR/$tdir")
        done
 
-       set_dir_limits 0 0
-       error "exceeded dir size limit $maxsize($MDSCOUNT) : $dirsize bytes"
+       error "rc=$rc, size=$dirsize/$maxsize, mdt=$MDSCOUNT, nfiles=$nfiles"
 }
 run_test 129 "test directory size limit ========================"
 
@@ -12882,38 +13002,21 @@ test_133e() {
 }
 run_test 133e "Verifying OST {read,write}_bytes nid stats ================="
 
-proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
-
-# Some versions of find (4.5.11, 4.5.14) included in CentOS 7.3-7.5 do
-# not honor the -ignore_readdir_race option correctly. So we call
-# error_ignore() rather than error() in these cases. See LU-11152.
-error_133() {
-       if (find --version; do_facet mds1 find --version) |
-               grep -q '\b4\.5\.1[1-4]\b'; then
-               error_ignore LU-11152 "$@"
-       else
-               error "$@"
-       fi
-}
-
 test_133f() {
-       # First without trusting modes.
-       local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
-       echo "proc_dirs='$proc_dirs'"
-       [ -n "$proc_dirs" ] || error "no proc_dirs on $HOSTNAME"
-       find $proc_dirs -exec cat '{}' \; &> /dev/null
+       [[ $(lustre_version_code $facet) -ge $(version_code 2.7.65) ]] ||
+               skip "too old lustre for get_param -R ($facet_ver)"
 
-       # Second verifying readability.
+       # verifying readability.
        $LCTL get_param -R '*' &> /dev/null
 
        # Verifing writability with badarea_io.
-       find $proc_dirs \
-               -ignore_readdir_race \
-               -type f \
-               -not -name force_lbug \
-               -not -name changelog_mask \
-               -exec badarea_io '{}' \; ||
-                       error_133 "find $proc_dirs failed"
+       $LCTL list_param -FR '*' | grep '=' | tr -d = |
+               egrep -v 'force_lbug|changelog_mask' | xargs badarea_io ||
+               error "client badarea_io failed"
+
+       # remount the FS in case writes/reads /proc break the FS
+       cleanup || error "failed to unmount"
+       setup || error "failed to setup"
 }
 run_test 133f "Check reads/writes of client lustre proc files with bad area io"
 
@@ -12930,10 +13033,10 @@ test_133g() {
                        log "$facet: too old lustre for get_param -R"
                fi
                if [ $facet_ver -ge $(version_code 2.5.54) ]; then
-                       do_facet $facet "$LCTL list_param -R '*' | grep '=' |
+                       do_facet $facet "$LCTL list_param -FR '*' | grep '=' |
                                tr -d = | egrep -v 'force_lbug|changelog_mask' |
                                xargs badarea_io" ||
-                                       error_133 "$facet badarea_io failed"
+                                       error "$facet badarea_io failed"
                else
                        skip_noexit "$facet: too old lustre for get_param -R"
                fi
@@ -12942,7 +13045,6 @@ test_133g() {
        # remount the FS in case writes/reads /proc break the FS
        cleanup || error "failed to unmount"
        setup || error "failed to setup"
-       true
 }
 run_test 133g "Check reads/writes of server lustre proc files with bad area io"
 
@@ -12953,24 +13055,21 @@ test_133h() {
                skip "Need MDS version at least 2.9.54"
 
        local facet
-
        for facet in client mds1 ost1; do
-               local facet_proc_dirs=$(do_facet $facet \
-                                       \\\ls -d $proc_regexp 2> /dev/null)
-               [ -z "$facet_proc_dirs" ] && error "no proc_dirs on $facet"
-               echo "${facet}_proc_dirs='$facet_proc_dirs'"
                # Get the list of files that are missing the terminating newline
-               local missing=($(do_facet $facet \
-                       find ${facet_proc_dirs} -type f \|              \
-                               while read F\; do                       \
-                                       awk -v FS='\v' -v RS='\v\v'     \
-                                       "'END { if(NR>0 &&              \
-                                       \\\$NF !~ /.*\\\n\$/)           \
-                                               print FILENAME}'"       \
-                                       '\$F'\;                         \
-                               done 2>/dev/null))
-               [ ${#missing[*]} -eq 0 ] ||
-                       error "files do not end with newline: ${missing[*]}"
+               local plist=$(do_facet $facet
+                       $LCTL list_param -FR '*' | grep '=' | tr -d =)
+               local ent
+               for ent in $plist; do
+                       local missing=$(do_facet $facet $LCTL get_param $ent \|\
+                               awk -v FS='\v' -v RS='\v\v' \
+                               "'END { if(NR>0 && \\\$NF !~ /.*\\\n\$/) \
+                                       print FILENAME}'" 2>/dev/null)
+                       [ -z $missing ] || {
+                               do_facet $facet $LCTL get_param $ent | od -An -tx1
+                               error "file does not end with newline: $facet-$ent"
+                       }
+               done
        done
 }
 run_test 133h "Proc files should end with newlines"
@@ -13530,10 +13629,19 @@ test_154A() {
        [ -z "$fid" ] && error "path2fid unable to get $tf FID"
 
        # check that we get the same pathname back
-       local found=$($LFS fid2path $MOUNT "$fid")
-       [ -z "$found" ] && error "fid2path unable to get '$fid' path"
-       [ "$found" == "$tf" ] ||
-               error "fid2path($fid=path2fid($tf)) = $found != $tf"
+       local rootpath
+       local found
+       for rootpath in "$MOUNT" "$MOUNT///" "$MOUNT/$tfile"; do
+               echo "$rootpath $fid"
+               found=$($LFS fid2path $rootpath "$fid")
+               [ -z "$found" ] && error "fid2path unable to get '$fid' path"
+               [ "$found" == "$tf" ] || error "fid2path $found != $tf"
+       done
+
+       # check wrong root path format
+       rootpath=$MOUNT"_wrong"
+       found=$($LFS fid2path $rootpath "$fid")
+       [ -z "$found" ] || error "should fail ($rootpath != $MOUNT)"
 }
 run_test 154A "lfs path2fid and fid2path basic checks"
 
@@ -15793,6 +15901,7 @@ test_184c() {
        local cmpn_arg=$(cmp -n 2>&1 | grep "invalid option")
        [ -n "$cmpn_arg" ] && skip_env "cmp does not support -n"
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
 
        local dir0=$DIR/$tdir/$testnum
        mkdir -p $dir0 || error "creating dir $dir0"
@@ -15840,6 +15949,7 @@ run_test 184c "Concurrent write and layout swap"
 
 test_184d() {
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
        [ -z "$(which getfattr 2>/dev/null)" ] &&
                skip_env "no getfattr command"
 
@@ -15876,6 +15986,7 @@ test_184e() {
        [[ $MDS1_VERSION -ge $(version_code 2.6.94) ]] ||
                skip "Need MDS version at least 2.6.94"
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
        [ -z "$(which getfattr 2>/dev/null)" ] &&
                skip_env "no getfattr command"
 
@@ -16366,16 +16477,31 @@ test_205a() { # Job stats
 }
 run_test 205a "Verify job stats"
 
-# LU-13117
+# LU-13117, LU-13597
 test_205b() {
+       job_stats="mdt.*.job_stats"
+       $LCTL set_param $job_stats=clear
        $LCTL set_param jobid_var=USER jobid_name="%e.%u"
        env -i USERTESTJOBSTATS=foolish touch $DIR/$tfile.1
-       do_facet $SINGLEMDS $LCTL get_param mdt.*.job_stats |
-               grep job_id: | grep foolish &&
+       do_facet $SINGLEMDS $LCTL get_param $job_stats |
+               grep "job_id:.*foolish" &&
                        error "Unexpected jobid found"
-       true
+       do_facet $SINGLEMDS $LCTL get_param $job_stats |
+               grep "open:.*min.*max.*sum" ||
+                       error "wrong job_stats format found"
 }
-run_test 205b "Verify job stats jobid parsing"
+run_test 205b "Verify job stats jobid and output format"
+
+# LU-13733
+test_205c() {
+       $LCTL set_param llite.*.stats=0
+       dd if=/dev/zero of=$DIR/$tfile.1 bs=4k count=1
+       $LCTL get_param llite.*.stats
+       $LCTL get_param llite.*.stats | grep \
+               "write_bytes *1 samples \[bytes\] 4096 4096 4096 16777216" ||
+                       error "wrong client stats format found"
+}
+run_test 205c "Verify client stats format"
 
 # LU-1480, LU-1773 and LU-1657
 test_206() {
@@ -16483,6 +16609,8 @@ test_209() {
        sync; sleep 5; sync;
 
        echo 3 > /proc/sys/vm/drop_caches
+       [ -f /sys/kernel/slab/ptlrpc_cache/shrink ] &&
+               echo 1 > /sys/kernel/slab/ptlrpc_cache/shrink
        req_before=$(awk '/ptlrpc_cache / { print $2 }' /proc/slabinfo)
 
        # open/close 500 times
@@ -16491,6 +16619,8 @@ test_209() {
        done
 
        echo 3 > /proc/sys/vm/drop_caches
+       [ -f /sys/kernel/slab/ptlrpc_cache/shrink ] &&
+               echo 1 > /sys/kernel/slab/ptlrpc_cache/shrink
        req_after=$(awk '/ptlrpc_cache / { print $2 }' /proc/slabinfo)
 
        echo "before: $req_before, after: $req_after"
@@ -16500,6 +16630,27 @@ test_209() {
 }
 run_test 209 "read-only open/close requests should be freed promptly"
 
+test_210() {
+       local pid
+
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:eW_E+eUc &
+       pid=$!
+       sleep 1
+
+       $LFS getstripe $DIR/$tfile
+       kill -USR1 $pid
+       wait $pid || error "multiop failed"
+
+       $MULTIOP $DIR/$tfile oO_RDONLY:eR_E+eUc &
+       pid=$!
+       sleep 1
+
+       $LFS getstripe $DIR/$tfile
+       kill -USR1 $pid
+       wait $pid || error "multiop failed"
+}
+run_test 210 "lfs getstripe does not break leases"
+
 test_212() {
        size=`date +%s`
        size=$((size % 8192 + 1))
@@ -17760,7 +17911,7 @@ run_test 230i "lfs migrate -m tolerates trailing slashes"
 
 test_230j() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
-       [ $MDS1_VERSION -lt $(version_code 2.11.52) ] &&
+       [ $MDS1_VERSION -lt $(version_code 2.13.52) ] &&
                skip "Need MDS version at least 2.11.52"
 
        $LFS mkdir -m 0 -c 1 $DIR/$tdir || error "mkdir $tdir failed"
@@ -17768,7 +17919,7 @@ test_230j() {
                error "create $tfile failed"
        cat /etc/passwd > $DIR/$tdir/$tfile
 
-       $LFS migrate -m 1 $DIR/$tdir
+       $LFS migrate -m 1 $DIR/$tdir || error "migrate failed"
 
        cmp /etc/passwd $DIR/$tdir/$tfile ||
                error "DoM file mismatch after migration"
@@ -17907,6 +18058,162 @@ test_230n() {
 }
 run_test 230n "Dir migration with mirrored file"
 
+test_230o() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local timeout=100
+
+       local restripe_status
+       local delta
+       local i
+       local j
+
+       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+
+       # in case "crush" hash type is not set
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       restripe_status=$(do_facet mds1 $LCTL get_param -n \
+                          mdt.*MDT0000.enable_dir_restripe)
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_restripe=1"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.enable_dir_restripe=$restripe_status"
+
+       mkdir $DIR/$tdir
+       createmany -m $DIR/$tdir/f 100 ||
+               error "create files under remote dir failed $i"
+       createmany -d $DIR/$tdir/d 100 ||
+               error "create dirs under remote dir failed $i"
+
+       for i in $(seq 2 $MDSCOUNT); do
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               $LFS setdirstripe -c $i $DIR/$tdir ||
+                       error "split -c $i $tdir failed"
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" "crush" $timeout ||
+                       error "dir split not finished"
+               delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
+                       awk '/migrate/ {sum += $2} END { print sum }')
+               echo "$delta files migrated when dir split from $((i - 1)) to $i stripes"
+               # delta is around total_files/stripe_count
+               [ $delta -lt $((200 /(i - 1))) ] ||
+                       error "$delta files migrated"
+       done
+}
+run_test 230o "dir split"
+
+test_230p() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local timeout=100
+
+       local restripe_status
+       local delta
+       local i
+       local j
+
+       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       restripe_status=$(do_facet mds1 $LCTL get_param -n \
+                          mdt.*MDT0000.enable_dir_restripe)
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_restripe=1"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.enable_dir_restripe=$restripe_status"
+
+       test_mkdir -c $MDSCOUNT -H crush $DIR/$tdir
+       createmany -m $DIR/$tdir/f 100 ||
+               error "create files under remote dir failed $i"
+       createmany -d $DIR/$tdir/d 100 ||
+               error "create dirs under remote dir failed $i"
+
+       for i in $(seq $((MDSCOUNT - 1)) -1 1); do
+               local mdt_hash="crush"
+
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               $LFS setdirstripe -c $i $DIR/$tdir ||
+                       error "split -c $i $tdir failed"
+               [ $i -eq 1 ] && mdt_hash="none"
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" $mdt_hash $timeout ||
+                       error "dir merge not finished"
+               delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
+                       awk '/migrate/ {sum += $2} END { print sum }')
+               echo "$delta files migrated when dir merge from $((i + 1)) to $i stripes"
+               # delta is around total_files/stripe_count
+               [ $delta -lt $((200 / i)) ] ||
+                       error "$delta files migrated"
+       done
+}
+run_test 230p "dir merge"
+
+test_230q() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local saved_threshold=$(do_facet mds1 \
+                       $LCTL get_param -n mdt.*-MDT0000.dir_split_count)
+       local saved_delta=$(do_facet mds1 \
+                       $LCTL get_param -n mdt.*-MDT0000.dir_split_delta)
+       local threshold=100
+       local delta=2
+       local total=0
+       local stripe_count=0
+       local stripe_index
+       local nr_files
+
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.dir_split_count=$saved_threshold"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.dir_split_delta=$saved_delta"
+       stack_trap "do_nodes $mdts $LCTL set_param mdt.*.dir_restripe_nsonly=1"
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_auto_split=1"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_split_count=$threshold"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_split_delta=$delta"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_restripe_nsonly=0"
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       $LFS mkdir -i -1 -c 1 $DIR/$tdir || error "mkdir $tdir failed"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir)
+
+       while [ $stripe_count -lt $MDSCOUNT ]; do
+               createmany -m $DIR/$tdir/f $total $((threshold * 3 / 2)) ||
+                       error "create sub files failed"
+               stat $DIR/$tdir > /dev/null
+               total=$((total + threshold * 3 / 2))
+               stripe_count=$((stripe_count + delta))
+               [ $stripe_count -gt $MDSCOUNT ] && stripe_count=$MDSCOUNT
+
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -c $DIR/$tdir" "$stripe_count" 40 ||
+                       error "stripe count $($LFS getdirstripe -c $DIR/$tdir) != $stripe_count"
+
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" "crush" 200 ||
+                       error "stripe hash $($LFS getdirstripe -H $DIR/$tdir) != crush"
+
+               nr_files=$($LFS getstripe -m $DIR/$tdir/* |
+                          grep -w $stripe_index | wc -l)
+               echo "$nr_files files on MDT$stripe_index after split"
+               [ $nr_files -lt $((total / (stripe_count - 1))) ] ||
+                       error "$nr_files files on MDT$stripe_index after split"
+
+               nr_files=$(ls $DIR/$tdir | wc -w)
+               [ $nr_files -eq $total ] ||
+                       error "total sub files $nr_files != $total"
+       done
+}
+run_test 230q "dir auto split"
+
 test_231a()
 {
        # For simplicity this test assumes that max_pages_per_rpc
@@ -18368,7 +18675,7 @@ test_247c() {
        $LFS fid2path $submount $fid && error "fid2path should fail"
        cleanup_247 $submount
 }
-run_test 247c "running fid2path outside root"
+run_test 247c "running fid2path outside subdirectory root"
 
 test_247d() {
        lctl get_param -n mdc.$FSNAME-MDT0000*.import | grep -q subtree ||
@@ -18381,11 +18688,28 @@ test_247d() {
        FILESET="$FILESET/$tdir" mount_client $submount ||
                error "mount $submount failed"
        trap "cleanup_247 $submount" EXIT
-       local fid=$($LFS path2fid $submount/dir1)
-       $LFS fid2path $submount $fid || error "fid2path should succeed"
+
+       local td=$submount/dir1
+       local fid=$($LFS path2fid $td)
+       [ -z "$fid" ] && error "path2fid unable to get $td FID"
+
+       # check that we get the same pathname back
+       local rootpath
+       local found
+       for rootpath in "$submount" "$submount///" "$submount/dir1"; do
+               echo "$rootpath $fid"
+               found=$($LFS fid2path $rootpath "$fid")
+               [ -n "found" ] || error "fid2path should succeed"
+               [ "$found" == "$td" ] || error "fid2path $found != $td"
+       done
+       # check wrong root path format
+       rootpath=$submount"_wrong"
+       found=$($LFS fid2path $rootpath "$fid")
+       [ -z "$found" ] || error "fid2path should fail ($rootpath != $submount)"
+
        cleanup_247 $submount
 }
-run_test 247d "running fid2path inside root"
+run_test 247d "running fid2path inside subdirectory root"
 
 # LU-8037
 test_247e() {
@@ -19654,6 +19978,36 @@ test_270g() {
 }
 run_test 270g "DoM: default DoM stripe size depends on free space"
 
+test_270h() {
+       [[ $MDS1_VERSION -ge $(version_code 2.13.53) ]] ||
+               skip "Need MDS version at least 2.13.53"
+
+       local mdtname=${FSNAME}-MDT0000-mdtlov
+       local dom=$DIR/$tdir/$tfile
+       local save="$TMP/$TESTSUITE-$TESTNAME.parameters"
+
+       save_lustre_params mds1 "lod.*.dom_stripesize" > $save
+       stack_trap "restore_lustre_params < $save; rm -f $save" EXIT
+
+       $LFS mkdir -i 0 -c 1 $DIR/$tdir
+       $LFS setstripe -E 1M -c1  -E -1 -c2 ${dom}_1 ||
+               error "can't create OST file"
+       # mirrored file with DOM entry in the second mirror
+       $LFS mirror extend -N -E 1M -L mdt -E eof -c2 ${dom}_1 ||
+               error "can't create mirror with DoM component"
+
+       do_facet mds1 $LCTL set_param -n lod.$mdtname.dom_stripesize=0
+
+       # DOM component in the middle and has other enries in the same mirror,
+       # should succeed but lost DoM component
+       $LFS setstripe --copy=${dom}_1 $dom ||
+               error "Can't create file from OST|DOM mirror layout"
+       # check new file has no DoM layout after all
+       [[ $($LFS getstripe -L $dom) != "mdt" ]] ||
+               error "File has DoM component while DoM is disabled"
+}
+run_test 270h "DoM: DoM stripe removal when disabled on server"
+
 test_271a() {
        [ $MDS1_VERSION -lt $(version_code 2.10.55) ] &&
                skip "Need MDS version at least 2.10.55"
@@ -21511,11 +21865,32 @@ test_398c() { # LU-4198
                --filename=$DIR/$tfile
        [ $? -eq 0 ] || error "fio mixed read write error"
 
+       echo "AIO with large block size ${size}M"
+       fio --name=rand-rw --rw=randrw --bs=${size}M --direct=1 \
+               --numjobs=1 --fallocate=none --ioengine=libaio \
+               --iodepth=16 --allow_file_create=0 --size=${size}M \
+               --filename=$DIR/$tfile
+       [ $? -eq 0 ] || error "fio large block size failed"
+
        rm -rf $DIR/$tfile
        $LCTL set_param debug="$saved_debug"
 }
 run_test 398c "run fio to test AIO"
 
+test_398d() { #  LU-13846
+       test -f aiocp || skip_env "no aiocp installed"
+       local aio_file=$DIR/aio_file
+
+       $LFS setstripe -c -1 -S 1M $DIR/$tfile $aio_file
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=1M count=64
+       aiocp -a $PAGE_SIZE -b 64M -s 64M -f O_DIRECT $DIR/$tfile $aio_file
+
+       diff $DIR/$tfile $aio_file || "file diff after aiocp"
+       rm -rf $DIR/$tfile $aio_file
+}
+run_test 398d "run aiocp to verify block size > stripe size"
+
 test_fake_rw() {
        local read_write=$1
        if [ "$read_write" = "write" ]; then
@@ -21658,6 +22033,7 @@ test_401a() { #LU-7437
        #count the number of parameters by "list_param -R"
        local params=$($LCTL list_param -R '*' 2>/dev/null | wc -l)
        #count the number of parameters by listing proc files
+       local proc_regexp="/{proc,sys}/{fs,sys,kernel/debug}/{lustre,lnet}/"
        local proc_dirs=$(eval \ls -d $proc_regexp 2>/dev/null)
        echo "proc_dirs='$proc_dirs'"
        [ -n "$proc_dirs" ] || error "no proc_dirs on $HOSTNAME"
@@ -21829,6 +22205,7 @@ test_405() {
                        skip "Layout swap lock is not supported"
 
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
 
        test_mkdir $DIR/$tdir
        swap_lock_test -d $DIR/$tdir ||
@@ -21979,6 +22356,8 @@ test_410()
 {
        [[ $CLIENT_VERSION -lt $(version_code 2.9.59) ]] &&
                skip "Need client version at least 2.9.59"
+       [ -f $LUSTRE/tests/kernel/kinode.ko ] ||
+               skip "Need MODULES build"
 
        # Create a file, and stat it from the kernel
        local testfile=$DIR/$tfile
@@ -22818,6 +23197,14 @@ test_423() {
 }
 run_test 423 "statfs should return a right data"
 
+test_424() {
+#define OBD_FAIL_PTLRPC_BULK_REPLY_ATTACH      0x522 | OBD_FAIL_ONCE
+       $LCTL set_param fail_loc=0x80000522
+       dd if=/dev/zero of=$DIR/$tfile bs=2M count=1 oflag=sync
+       rm -f $DIR/$tfile
+}
+run_test 424 "simulate ENOMEM in ptl_send_rpc bulk reply ME attach"
+
 prep_801() {
        [[ $MDS1_VERSION -lt $(version_code 2.9.55) ]] ||
        [[ $OST1_VERSION -lt $(version_code 2.9.55) ]] &&